## mingw-w64-vtk-9.4.2-2.src.tar.zst

=== Common/DataModel/CMakeLists.txt ===
set(classes
  vtkAMRBox
  vtkAMRUtilities
  vtkAbstractCellArray
  vtkAbstractCellLinks
  vtkAbstractCellLocator
  vtkAbstractElectronicData
  vtkAbstractPointLocator
  vtkAdjacentVertexIterator
  vtkAnimationScene
  vtkAnnotation
  vtkAnnotationLayers
  vtkAnnulus
  vtkArrayData
  vtkAtom
  vtkAttributesErrorMetric
  vtkBSPCuts
  vtkBSPIntersections
  vtkBezierCurve
  vtkBezierHexahedron
  vtkBezierInterpolation
  vtkBezierQuadrilateral
  vtkBezierTetra
  vtkBezierTriangle
  vtkBezierWedge
  vtkBiQuadraticQuad
  vtkBiQuadraticQuadraticHexahedron
  vtkBiQuadraticQuadraticWedge
  vtkBiQuadraticTriangle
  vtkBond
  vtkBoundingBox
  vtkBox
  vtkCell
  vtkCell3D
  vtkCellArray
  vtkCellArrayIterator
  vtkCellAttribute
  vtkCellAttributeCalculator
  vtkCellData
  vtkCellGrid
  vtkCellGridBoundsQuery
  vtkCellGridCopyQuery
  vtkCellGridEvaluator
  vtkCellGridRangeQuery
  vtkCellGridQuery
  vtkCellGridResponders
  vtkCellGridSidesCache
  vtkCellGridSidesQuery
  vtkCellIterator
  vtkCellLinks
  vtkCellLocator
  vtkCellLocatorStrategy
  vtkCellMetadata
  vtkCellTreeLocator
  vtkCellTypes
  vtkClosestNPointsStrategy
  vtkClosestPointStrategy
  vtkCompositeDataIterator
  vtkCompositeDataSet
  vtkCone
  vtkConvexPointSet
  vtkCoordinateFrame
  vtkCubicLine
  vtkCylinder
  vtkDataAssembly
  vtkDataAssemblyUtilities
  vtkDataObject
  vtkDataObjectCollection
  vtkDataObjectTree
  vtkDataObjectTreeIterator
  vtkDataObjectTypes
  vtkDataSet
  vtkDataSetAttributes
  vtkDataSetAttributesFieldList
  vtkDataSetCellIterator
  vtkDataSetCollection
  vtkDirectedAcyclicGraph
  vtkDirectedGraph
  vtkDistributedGraphHelper
  vtkEdgeListIterator
  vtkEdgeTable
  vtkEmptyCell
  vtkExplicitStructuredGrid
  vtkExtractStructuredGridHelper
  vtkFieldData
  vtkFindCellStrategy
  vtkGenericAdaptorCell
  vtkGenericAttribute
  vtkGenericAttributeCollection
  vtkGenericCell
  vtkGenericCellIterator
  vtkGenericCellTessellator
  vtkGenericDataSet
  vtkGenericEdgeTable
  vtkGenericInterpolatedVelocityField
  vtkGenericPointIterator
  vtkGenericSubdivisionErrorMetric
  vtkGeometricErrorMetric
  vtkGraph
  vtkGraphEdge
  vtkGraphInternals
  vtkHexagonalPrism
  vtkHexahedron
  vtkHierarchicalBoxDataSet
  vtkHigherOrderCurve
  vtkHigherOrderHexahedron
  vtkHigherOrderInterpolation
  vtkHigherOrderQuadrilateral
  vtkHigherOrderTetra
  vtkHigherOrderTriangle
  vtkHigherOrderWedge
  vtkHyperTree
  vtkHyperTreeGrid
  vtkHyperTreeGridLocator
  vtkHyperTreeGridGeometricLocator
  vtkHyperTreeGridNonOrientedCursor
  vtkHyperTreeGridNonOrientedGeometryCursor
  vtkHyperTreeGridNonOrientedUnlimitedGeometryCursor
  vtkHyperTreeGridNonOrientedMooreSuperCursor
  vtkHyperTreeGridNonOrientedMooreSuperCursorLight
  vtkHyperTreeGridNonOrientedUnlimitedMooreSuperCursor
  vtkHyperTreeGridNonOrientedSuperCursor
  vtkHyperTreeGridNonOrientedSuperCursorLight
  vtkHyperTreeGridNonOrientedUnlimitedSuperCursor
  vtkHyperTreeGridNonOrientedVonNeumannSuperCursor
  vtkHyperTreeGridNonOrientedVonNeumannSuperCursorLight
  vtkHyperTreeGridOrientedCursor
  vtkHyperTreeGridOrientedGeometryCursor
  vtkImageData
  vtkImageIterator
  vtkImageTransform
  vtkImplicitBoolean
  vtkImplicitDataSet
  vtkImplicitFunction
  vtkImplicitFunctionCollection
  vtkImplicitHalo
  vtkImplicitSelectionLoop
  vtkImplicitSum
  vtkImplicitVolume
  vtkImplicitWindowFunction
  vtkInEdgeIterator
  vtkIncrementalOctreeNode
  vtkIncrementalOctreePointLocator
  vtkIncrementalPointLocator
  vtkInformationQuadratureSchemeDefinitionVectorKey
  vtkIterativeClosestPointTransform
  vtkKdNode
  vtkKdTree
  vtkKdTreePointLocator
  vtkLagrangeCurve
  vtkLagrangeHexahedron
  vtkLagrangeInterpolation
  vtkLagrangeQuadrilateral
  vtkLagrangeTetra
  vtkLagrangeTriangle
  vtkLagrangeWedge
  vtkLine
  vtkLocator
  vtkMarchingCubesTriangleCases
  vtkMarchingCubesPolygonCases
  vtkMarchingSquaresLineCases
  vtkMeanValueCoordinatesInterpolator
  vtkMergePoints
  vtkMolecule
  vtkMultiBlockDataSet
  vtkMultiPieceDataSet
  vtkMutableDirectedGraph
  vtkMutableUndirectedGraph
  vtkNonLinearCell
  vtkNonMergingPointLocator
  vtkOctreePointLocator
  vtkOctreePointLocatorNode
  vtkOrderedTriangulator
  vtkOutEdgeIterator
  vtkPartitionedDataSet
  vtkPartitionedDataSetCollection
  vtkPath
  vtkPentagonalPrism
  vtkPerlinNoise
  vtkPiecewiseFunction
  vtkPixel
  vtkPixelExtent
  vtkPixelTransfer
  vtkPlane
  vtkPlaneCollection
  vtkPlanes
  vtkPlanesIntersection
  vtkPointData
  vtkPointLocator
  vtkPointSet
  vtkPointSetCellIterator
  vtkPointsProjectedHull
  vtkPolyData
  vtkPolyDataCollection
  vtkPolyLine
  vtkPolyPlane
  vtkPolyVertex
  vtkPolygon
  vtkPolyhedron
  vtkPolyhedronUtilities
  vtkPyramid
  vtkQuad
  vtkQuadraticEdge
  vtkQuadraticHexahedron
  vtkQuadraticLinearQuad
  vtkQuadraticLinearWedge
  vtkQuadraticPolygon
  vtkQuadraticPyramid
  vtkQuadraticQuad
  vtkQuadraticTetra
  vtkQuadraticTriangle
  vtkQuadraticWedge
  vtkQuadratureSchemeDefinition
  vtkQuadric
  vtkRectilinearGrid
  vtkReebGraph
  vtkReebGraphSimplificationMetric
  vtkSelection
  vtkSelectionNode
  vtkSimpleCellTessellator
  vtkSmoothErrorMetric
  vtkSortFieldData
  vtkSphere
  vtkSpheres
  vtkSphericalPointIterator
  vtkSpline
  vtkStaticCellLinks
  vtkStaticCellLocator
  vtkStaticPointLocator
  vtkStaticPointLocator2D
  vtkStructuredCellArray
  vtkStructuredData
  vtkStructuredExtent
  vtkStructuredGrid
  vtkStructuredPoints
  vtkStructuredPointsCollection
  vtkSuperquadric
  vtkTable
  vtkTetra
  vtkTree
  vtkTreeBFSIterator
  vtkTreeDFSIterator
  vtkTreeIterator
  vtkTriQuadraticHexahedron
  vtkTriQuadraticPyramid
  vtkTriangle
  vtkTriangleStrip
  vtkUndirectedGraph
  vtkUniformGrid
  vtkUniformHyperTreeGrid
  vtkUnstructuredGrid
  vtkUnstructuredGridBase
  vtkUnstructuredGridCellIterator
  vtkVertex
  vtkVertexListIterator
  vtkVoxel
  vtkWedge
  vtkXMLDataElement

  # New classes for AMR
  vtkAMRDataInternals
  vtkAMRInformation
  vtkNonOverlappingAMR
  vtkOverlappingAMR
  vtkUniformGridAMR
  vtkUniformGridAMRDataIterator)

set(template_classes
  vtkAngularPeriodicDataArray
  vtkArrayListTemplate
  vtkMappedUnstructuredGrid
  vtkMappedUnstructuredGridCellIterator
  vtkPeriodicDataArray
  vtkStaticCellLinksTemplate
  vtkStaticEdgeLocatorTemplate
  vtkStaticFaceHashLinksTemplate)

set(nowrap_classes
  vtkHyperTreeGridEntry
  vtkHyperTreeGridGeometryEntry
  vtkHyperTreeGridGeometryUnlimitedEntry
  vtkHyperTreeGridGeometryLevelEntry
  vtkHyperTreeGridGeometryUnlimitedLevelEntry
  vtkHyperTreeGridLevelEntry)

set(headers
  vtkCellGridResponder.h
  vtkCellGridResponderBase.h
  vtkCellType.h
  vtkColor.h
  vtkDataAssemblyVisitor.h
  vtkDataObjectTreeInternals.h
  vtkHyperTreeGridScales.h
  vtkHyperTreeGridTools.h
  vtkIntersectionCounter.h
  vtkLabelMapLookup.h
  vtkRect.h
  vtkVector.h
  vtkVectorOperators.h)

set(nowrap_headers
  vtkCompositeDataSetNodeReference.h
  vtkCompositeDataSetRange.h
  vtkDataObjectImplicitBackendInterface.h
  vtkDataObjectTreeRange.h
  vtkPolyDataInternals.h)

set(templates
  vtkCompositeDataSet.txx)

set(private_templates
  vtkDataObjectImplicitBackendInterface.txx
  vtkImageIterator.txx)

include(vtkTypeLists)

set(instantiation_sources)
foreach (INSTANTIATION_VALUE_TYPE IN LISTS vtk_numeric_types)
  # only instantiate fundamental types, not typedefs
  if (INSTANTIATION_VALUE_TYPE STREQUAL "vtkIdType")
    continue()
  endif ()
  vtk_type_to_camel_case("${INSTANTIATION_VALUE_TYPE}" _cased_type)
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/vtkDataObjectImplicitBackendInstantiate.cxx.in"
    "${CMAKE_CURRENT_BINARY_DIR}/vtkDataObjectImplicitBackendInstantiate${_cased_type}.cxx")

    list(APPEND instantiation_sources
      "${CMAKE_CURRENT_BINARY_DIR}/vtkDataObjectImplicitBackendInstantiate${_cased_type}.cxx")
endforeach()

# Hand written (de)serialization routines
set(serialization_helper_sources)

if (VTK_WRAP_SERIALIZATION)
  list(APPEND serialization_helper_sources
    vtkCellArraySerDesHelper.cxx
    vtkDataSetAttributesSerDesHelper.cxx
    vtkMultiBlockDataSetSerDesHelper.cxx
    vtkPartitionedDataSetSerDesHelper.cxx
    vtkPartitionedDataSetCollectionSerDesHelper.cxx
    vtkPiecewiseFunctionSerDesHelper.cxx
    vtkTableSerDesHelper.cxx
    vtkUnstructuredGridSerDesHelper.cxx)
endif ()    

set(sources
  ${serialization_helper_sources}
  ${instantiation_sources})

vtk_module_add_module(VTK::CommonDataModel
  CLASSES           ${classes}
  NOWRAP_CLASSES    ${nowrap_classes}
  TEMPLATES         ${templates}
  TEMPLATE_CLASSES  ${template_classes}
  HEADERS           ${headers}
  SOURCES           ${sources}
  NOWRAP_HEADERS    ${nowrap_headers}
  PRIVATE_TEMPLATES ${private_templates})
vtk_add_test_mangling(VTK::CommonDataModel)

=== Filters/Statistics/CMakeLists.txt ===
set(classes
  vtkAutoCorrelativeStatistics
  vtkBivariateLinearTableThreshold
  vtkComputeQuantiles
  vtkComputeQuartiles
  vtkContingencyStatistics
  vtkCorrelativeStatistics
  vtkDescriptiveStatistics
  vtkExtractFunctionalBagPlot
  vtkExtractHistogram
  vtkHighestDensityRegionsStatistics
  vtkKMeansDistanceFunctor
  vtkKMeansDistanceFunctorCalculator
  vtkKMeansStatistics
  vtkLengthDistribution
  vtkMultiCorrelativeStatistics
  vtkOrderStatistics
  vtkPCAStatistics
  vtkStatisticsAlgorithm
  vtkStrahlerMetric
  vtkStreamingStatistics)

set(nowrap_headers
  vtkStatisticsAlgorithmPrivate.h)

vtk_module_add_module(VTK::FiltersStatistics
  CLASSES ${classes}
  NOWRAP_HEADERS ${nowrap_headers})
vtk_add_test_mangling(VTK::FiltersStatistics)

=== IO/CatalystConduit/CMakeLists.txt ===
set(classes
  vtkConduitArrayUtilities
  vtkConduitSource
  vtkConduitToDataObject
  vtkDataObjectToConduit)

vtk_module_add_module(VTK::IOCatalystConduit
  CLASSES ${classes})

vtk_add_test_mangling(VTK::IOCatalystConduit)
add_subdirectory(Catalyst)

=== IO/NetCDF/CMakeLists.txt ===
set(classes
  vtkMPASReader
  vtkNetCDFCAMReader
  vtkNetCDFCFReader
  vtkNetCDFCFWriter
  vtkNetCDFPOPReader
  vtkNetCDFReader
  vtkNetCDFUGRIDReader
  vtkSLACParticleReader
  vtkSLACReader)

vtk_module_add_module(VTK::IONetCDF
  CLASSES ${classes})
vtk_add_test_mangling(VTK::IONetCDF)

=== Interaction/Style/CMakeLists.txt ===
set(classes
  vtkInteractorStyleDrawPolygon
  vtkInteractorStyleFlight
  vtkInteractorStyleImage
  vtkInteractorStyleJoystickActor
  vtkInteractorStyleJoystickCamera
  vtkInteractorStyleMultiTouchCamera
  vtkInteractorStyleRubberBand2D
  vtkInteractorStyleRubberBand3D
  vtkInteractorStyleRubberBandPick
  vtkInteractorStyleRubberBandZoom
  vtkInteractorStyleTerrain
  vtkInteractorStyleTrackball
  vtkInteractorStyleTrackballActor
  vtkInteractorStyleTrackballCamera
  vtkInteractorStyleUnicam
  vtkInteractorStyleUser

  vtkInteractorStyleSwitch
  vtkParallelCoordinatesInteractorStyle)

if (ANDROID OR APPLE_IOS)
  set(style_override "vtkInteractorStyleMultiTouchCamera")
else ()
  set(style_override "vtkInteractorStyleSwitch")
endif ()
vtk_object_factory_declare(
  BASE vtkInteractorStyleSwitchBase
  OVERRIDE "${style_override}")

vtk_object_factory_configure(
  SOURCE_FILE vtk_object_factory_source
  HEADER_FILE vtk_object_factory_header
  EXPORT_MACRO "VTKINTERACTIONSTYLE_EXPORT")

# Hand written (de)serialization routines
set(serialization_helper_sources)
if (VTK_WRAP_SERIALIZATION)
  list(APPEND serialization_helper_sources
    vtkInteractorStyleSwitchSerDesHelper.cxx)
endif ()

set(sources
  ${vtk_object_factory_source}
  ${serialization_helper_sources})

vtk_module_add_module(VTK::InteractionStyle
  CLASSES ${classes}
  SOURCES ${sources}
  PRIVATE_HEADERS ${vtk_object_factory_header})
vtk_add_test_mangling(VTK::InteractionStyle)

=== ThirdParty/exodusII/CMakeLists.txt ===
vtk_module_third_party_internal(
  LICENSE_FILES
    "vtkexodusII/COPYRIGHT"
  SPDX_LICENSE_IDENTIFIER
    "BSD-3-Clause"
  SPDX_COPYRIGHT_TEXT
    "Copyright (c) 2005-2017 National Technology & Engineering Solutions of Sandia, LLC (NTESS)"
  SPDX_DOWNLOAD_LOCATION
    "git+https://gitlab.kitware.com/third-party/seacas.git@exodus/for/vtk-20240826-master-gaeee5aa1#packages/seacas/libraries/exodus"
  VERSION
    "9.3f"
  STANDARD_INCLUDE_DIRS)

#configure_file(
#  "${CMAKE_CURRENT_SOURCE_DIR}/vtk_exodusII.h.in"
#  "${CMAKE_CURRENT_BINARY_DIR}/vtk_exodusII.h")

vtk_module_install_headers(
#  FILES "${CMAKE_CURRENT_BINARY_DIR}/vtk_exodusII.h")
  FILES "${CMAKE_CURRENT_SOURCE_DIR}/vtk_exodusII.h")

=== Common/DataModel/Testing/Python/CMakeLists.txt ===
# set(TestCellGrid_ARGS
#   -D DATA{../Data/Input/dgHex2d.dg}
# )

vtk_add_test_python(
  ImplicitSum.py
#  LineIntersectQuadraticCells.py
  PerlinNoise.py
  SelectionLoop.py
  TestBoxPlaneIntersection.py
  TestCellGrid.py,NO_VALID
  TestComputeBounds.py,NO_DATA,NO_VALID
  TestCopyStructuredData.py,NO_DATA,NO_VALID
  TestGetBounds.py,NO_DATA,NO_VALID
  TestGetBounds2.py,NO_DATA,NO_VALID
  TestNumericArrayImageData.py,NO_DATA,NO_VALID
  TestPartitionedData.py,NO_DATA,NO_VALID
  TestPointInPolygon.py,NO_DATA,NO_VALID
  TestPolyDataGetCellPoints.py,NO_DATA,NO_VALID
  TestQuadricClustering.py
  TestStaticPointLocator.py,NO_DATA,NO_VALID
  TestStaticPointLocator2.py,NO_DATA,NO_VALID
  TestStaticPointLocator2D.py,NO_DATA,NO_VALID
  TestStaticPointLocator3.py,NO_DATA,NO_VALID
  TestStaticPointLocatorWithDataSet.py,NO_DATA,NO_VALID
  TestStarPolygon.py,NO_DATA,NO_VALID
  TestStructuredGrid.py
  TestTemplates.py,NO_DATA,NO_VALID
  headBone.py
  scalarColors.py
  scalarConn.py
  TestConvexPointSet.py
  otherDataSetAttributes.py,NO_DATA,NO_VALID
  quadricCut.py
  quadraticQuadDeriv.py,NO_VALID
  Test3DCellsEvaluatePosition.py,NO_DATA,NO_VALID,NO_OUTPUT
  TestICPTransform.py
  TestMolecule.py,NO_VALID
  TestClipPolyhedra.py
  TestClipPolyLine.py
  TestPolyhedronCutter.py,NO_DATA,NO_VALID
  TestHyperTreeGrid2DFull.py,NO_DATA,NO_VALID
  TestHyperTreeGrid2DFullGI.py,NO_DATA,NO_VALID
  TestHyperTreeGrid2DMask.py,NO_DATA,NO_VALID
  TestHyperTreeGrid2DWithFilters.py,NO_DATA,NO_VALID
  TestHyperTreeGrid3DFull.py,NO_DATA,NO_VALID
  TestHyperTreeGrid3DMask.py,NO_DATA,NO_VALID
  TestHyperTreeGrid3DWithFilters.py,NO_DATA,NO_VALID
  TestHyperTreeGrid3DMandel.py,NO_DATA,NO_VALID
  TestUniformHyperTreeGrid2DFull.py
  TestUniformHyperTreeGrid2DMask.py
  TestUniformHyperTreeGrid2DWithFilters.py,NO_DATA,NO_VALID
  TestUniformHyperTreeGrid3DWithFilters.py,NO_DATA,NO_VALID
  TestHyperTreeGrid3DCursorsMandel.py,NO_DATA,NO_VALID
  TestCompareDataSet.py,NO_DATA,NO_VALID
  )

=== Examples/Emscripten/Cxx/ConeMultiBackend/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
project(ConeMultiBackend)

# -----------------------------------------------------------------------------
# EMSCRIPTEN only
# -----------------------------------------------------------------------------

if (NOT EMSCRIPTEN)
  message("Skipping example: This needs to run inside an Emscripten build environment")
  return ()
endif ()

# -----------------------------------------------------------------------------
# Handle VTK dependency
# -----------------------------------------------------------------------------

find_package(VTK
  COMPONENTS
    FiltersSources      # VTK pipeline
    InteractionStyle    # Mouse handling
    RenderingOpenGL2    # For Rendering with OpenGL
    RenderingWebGPU     # For Rendering with WebGPU
    RenderingUI         # For SDL2 Window
)

if (NOT VTK_FOUND)
  message("Skipping example: ${VTK_NOT_FOUND_MESSAGE}")
  return ()
endif ()

# -----------------------------------------------------------------------------
# Compile example code
# -----------------------------------------------------------------------------

add_executable(ConeMultiBackend ConeMultiBackend.cxx)
target_link_libraries(ConeMultiBackend PRIVATE ${VTK_LIBRARIES})

# -----------------------------------------------------------------------------
# WebAssembly build options
# -----------------------------------------------------------------------------
set(emscripten_link_options)

list(APPEND emscripten_link_options
  "-sWASM=1"
  "-sMODULARIZE=1"
  "-sASYNCIFY=1"
  "-sALLOW_MEMORY_GROWTH=1"
  "-sEXPORT_NAME=createConeMultiBackendModule"
  "-sEXPORTED_RUNTIME_METHODS=['ENV']" # ENV holds the environment variables accessible by C getenv
)

target_link_options(ConeMultiBackend
  PUBLIC
    ${emscripten_link_options}
)

# -----------------------------------------------------------------------------
# VTK modules initialization
# -----------------------------------------------------------------------------

vtk_module_autoinit(
  TARGETS  ConeMultiBackend
  MODULES  ${VTK_LIBRARIES}
)

# -----------------------------------------------------------------------------
# Copy HTML to build directory
# -----------------------------------------------------------------------------

add_custom_command(
  TARGET ConeMultiBackend
  COMMAND
    ${CMAKE_COMMAND} -E copy_directory
      "${CMAKE_CURRENT_SOURCE_DIR}/web"
      "${CMAKE_CURRENT_BINARY_DIR}"
)

=== IO/IOSS/Testing/Cxx/CMakeLists.txt ===
vtk_add_test_cxx(vtkIOIOSSCxxTests tests
  TestIOSSApplyDisplacementsCGNS.cxx
  TestIOSSAssemblies.cxx,NO_VALID
  TestIOSSAttributes.cxx,NO_VALID
  TestIOSSCGNS.cxx
  TestIOSSExodus.cxx,NO_VALID
  TestIOSSExodusMergeEntityBlocks.cxx,NO_VALID
  TestIOSSExodusParallelWriter.cxx
  TestIOSSExodusRestarts.cxx,NO_VALID
  TestIOSSExodusSetArrays.cxx
  TestIOSSExodusWriterCrinkleClip.cxx
  TestIOSSExodusWriterClip.cxx
  TestIOSSExodusWriter.cxx
  TestIOSSFilePatternMatching.cxx,NO_VALID
  TestIOSSNoElementBlocks.cxx,NO_VALID
  TestIOSSReadAllFilesToDetermineStructure.cxx,NO_VALID
  TestIOSSTri6.cxx
  TestIOSSUnsupported.cxx,NO_VALID
  TestIOSSWedge21.cxx
  TestIOSSGhostArray.cxx,NO_VALID
)

if (TARGET VTK::catalyst)
  vtk_add_test_cxx(vtkIOIOSSCxxTests tests
    TestIOSSCatalystCGNS.cxx
    TestIOSSCatalystExodus.cxx
  )
endif()

if (VTK_USE_LARGE_DATA)
  vtk_add_test_cxx(vtkIOIOSSCxxTests tests
    TestIOSSSuperelements.cxx,NO_VALID)
endif()

if (TARGET VTK::FiltersParallel AND TARGET VTK::RenderingParallel AND TARGET VTK::mpi)
  set (vtkIOIOSSCxxTests_NUMPROCS 4)
  vtk_add_test_mpi(vtkIOIOSSCxxTests tests
    TestIOSSExodusParallelWriter.cxx,TESTING_DATA
    TestIOSSExodusPartitionedFiles.cxx,TESTING_DATA
    TestIOSSExodusRestarts.cxx,NO_VALID,TESTING_DATA)
  if (TARGET VTK::catalyst)
    vtk_add_test_mpi(vtkIOIOSSCxxTests tests
      TestIOSSCatalystExodus.cxx,TESTING_DATA
    )
  endif ()
endif()

vtk_test_cxx_executable(vtkIOIOSSCxxTests tests)

=== IO/Import/Testing/Cxx/CMakeLists.txt ===
# This is an alternative  way to add a named test that uses a common executable
# Use this if it does not require MPI

set(TEMP "${_vtk_build_TEST_OUTPUT_DATA_DIRECTORY}")

vtk_add_test_cxx(vtkIOImportCxxTests tests
  OBJImporter-TwoTrianglesWithNegativeIndices,TestOBJImporter.cxx
    DATA{../Data/Input/TwoTrianglesWithNegativeIndices.obj}
    DATA{../Data/Input/TwoTrianglesWithNegativeIndices.mtl}
    DATA{../Data/Input/noise.png}
)

vtk_add_test_cxx(vtkIOImportCxxTests tests
  OBJImport-SolidAndTextured,TestOBJImporter.cxx
    DATA{../Data/Input/cube-scene.obj}
    DATA{../Data/Input/cube-scene.mtl}
    DATA{../Data/Input/noise.png}
)

vtk_add_test_cxx(vtkIOImportCxxTests tests
  OBJImport-MixedOrder1,TestOBJImporter.cxx
    DATA{../Data/Input/boxes_2.obj}
    DATA{../Data/Input/boxes_2.obj.mtl}
    DATA{../Data/Input/flare.jpg}
)

vtk_add_test_cxx(vtkIOImportCxxTests tests
  OBJImport-NoMTL,TestOBJImporter.cxx
    DATA{../Data/Input/boxes_3_no_mtl.obj}
    DATA{../Data/Input/boxes_2.obj.mtl}
    DATA{../Data/Input/flare.jpg}
)

vtk_add_test_cxx(vtkIOImportCxxTests tests
  OBJImport-MTLwithoutTextureFile,TestOBJImporter.cxx
    DATA{../Data/Input/boxes_4_mtl_no_texture.obj}
    DATA{../Data/Input/boxes_4_mtl_no_texture.obj.mtl}
)

vtk_add_test_cxx(vtkIOImportCxxTests tests
  TestOBJImporter-DuplicateMaps,TestOBJImporter.cxx
    DATA{../Data/Input/TestOBJImporter.obj}
    DATA{../Data/Input/TestOBJImporter.mtl}
    DATA{../Data/Input/TestOBJImporter.png}
)

vtk_add_test_cxx(vtkIOImportCxxTests tests
  TestOBJImporter-SharedMtl,TestOBJImporter.cxx
    DATA{../Data/Input/TestOBJImporter-SharedMtl.obj}
    DATA{../Data/Input/TestOBJImporter-SharedMtl.mtl}
)


vtk_add_test_cxx(vtkIOImportCxxTests tests
  TestOBJImporter-VtNoIndices,TestOBJImporter.cxx
    DATA{../Data/Input/TestOBJImporter-VtNoIndices.obj}
    DATA{../Data/Input/TestOBJImporter-VtNoIndices.mtl}
    DATA{../Data/Input/TestOBJImporter-VtNoIndices.png}
)

vtk_add_test_cxx(vtkIOImportCxxTests tests
  TestOBJImporter-ScalarsDuplication,TestOBJImporter.cxx
    DATA{../Data/Input/TestOBJImporter-ScalarsDuplication.obj}
)

# Test a malformed file
vtk_add_test_cxx(vtkIOImportCxxTests tests
  TestOBJImporter-Malformed,TestOBJImporter.cxx,NO_VALID
    DATA{../Data/Input/malformed.obj}
)

# Test an invalid file
vtk_add_test_cxx(vtkIOImportCxxTests tests
  TestOBJImporter-Invalid,TestOBJImporter.cxx,NO_VALID
    DATA{../Data/Input/world_invalid.obj}
)

# Test an file with an invalid image
vtk_add_test_cxx(vtkIOImportCxxTests tests
  TestGLTFImporter-Invalid,TestGLTFImporterInvalid.cxx,NO_VALID
    DATA{../Data/glTF/invalid.gltf}
    DATA{../Data/glTF/Duck0.bin}
)

# (vtk/vtk#19097) This test is skipped on wasm architecture.
if (NOT CMAKE_SYSTEM_NAME STREQUAL "Emscripten") 
  set_tests_properties(VTK::IOImportCxx-TestOBJImporter-Malformed PROPERTIES PASS_REGULAR_EXPRESSION "Unexpected point indice value")
  set_tests_properties(VTK::IOImportCxx-TestOBJImporter-Malformed PROPERTIES FAIL_REGULAR_EXPRESSION "")
endif ()
  set_tests_properties(VTK::IOImportCxx-TestOBJImporter-Invalid PROPERTIES PASS_REGULAR_EXPRESSION "Error reading point with index")
  set_tests_properties(VTK::IOImportCxx-TestOBJImporter-Invalid PROPERTIES FAIL_REGULAR_EXPRESSION "")
  set_tests_properties(VTK::IOImportCxx-TestGLTFImporter-Invalid PROPERTIES PASS_REGULAR_EXPRESSION "Failed to open file")
  set_tests_properties(VTK::IOImportCxx-TestGLTFImporter-Invalid PROPERTIES FAIL_REGULAR_EXPRESSION "")

vtk_add_test_cxx(vtkIOImportCxxTests tests
  TestVRMLImporter.cxx,NO_VALID
  TestVRMLNormals.cxx
  )

vtk_add_test_cxx(vtkIOImportCxxTests tests
  TestGLTFImporter,TestGLTFImporter.cxx DATA{../Data/glTF/Avocado/Avocado.glb} -1 1 0 0
)

vtk_add_test_cxx(vtkIOImportCxxTests tests
  LOOSE_VALID
  TestGLTFImporterPBR,TestGLTFImporter.cxx DATA{../Data/glTF/WaterBottle/WaterBottle.glb} -1 1 0 0
)

vtk_add_test_cxx(vtkIOImportCxxTests tests
  TestGLTFImporterKHRLightsPunctual,TestGLTFImporter.cxx DATA{../Data/glTF/Lights/lights.gltf} 0 1 5 1
)

vtk_add_test_cxx(vtkIOImportCxxTests tests
  TestGLTFImporterCamera,TestGLTFImporter.cxx DATA{../Data/glTF/Cameras/Cameras.gltf} 1 1 0 2
)

vtk_add_test_cxx(vtkIOImportCxxTests tests
  TestGLTFImporterUnlit,TestGLTFImporter.cxx DATA{../Data/glTF/UnlitTest/UnlitTest.glb} -1 2 0 0
)

vtk_add_test_cxx(vtkIOImportCxxTests tests
  TestGLTFImporterURITexture,TestGLTFImporter.cxx DATA{../Data/glTF/Lantern/Lantern.gltf} -1 3 0 0
   DATA{../Data/glTF/Lantern/Lantern.bin}
   DATA{../Data/glTF/Lantern/Lantern_baseColor.png}
   DATA{../Data/glTF/Lantern/Lantern_emissive.png}
   DATA{../Data/glTF/Lantern/Lantern_normal.png}
   DATA{../Data/glTF/Lantern/Lantern_roughnessMetallic.png}
)

vtk_add_test_cxx(vtkIOImportCxxTests tests
  TestGLTFImporterHierarchy,TestGLTFImporterHierarchy.cxx DATA{../Data/glTF/ABeautifulGame/ABeautifulGame.glb} -1
)

vtk_add_test_cxx(vtkIOImportCxxTests tests
  NO_VALID
  TestImportGLFTExportOBJ,TestImportExportOBJ.cxx
  DATA{../Data/glTF/Avocado/Avocado.glb}
  ${TEMP}/Avocado
)

vtk_add_test_cxx(vtkIOImportCxxTests tests
  NO_VALID
  TestImport3DSExportOBJ,TestImportExportOBJ.cxx
  DATA{../../../../Testing/Data/iflamigm.3ds}
  ${TEMP}/iflamigm
)

vtk_add_test_cxx(vtkIOImportCxxTests tests
  TestImport3DS,TestImportOBJ.cxx
  ${TEMP}/iflamigm.obj
  ${TEMP}/iflamigm.mtl
  ${TEMP}
)

set_tests_properties(VTK::IOImportCxx-TestImport3DS
      PROPERTIES
      DEPENDS
      "VTK::IOImportCxx-TestImport3DSExportOBJ"
)

vtk_add_test_cxx(vtkIOImportCxxTests tests
  TestImportGLFT,TestImportOBJ.cxx
  ${TEMP}/Avocado.obj
  ${TEMP}/Avocado.mtl
  ${TEMP}
)

set_tests_properties(VTK::IOImportCxx-TestImportGLFT
      PROPERTIES
      DEPENDS
      "VTK::IOImportCxx-TestImportGLFTExportOBJ"
)

vtk_test_cxx_executable(vtkIOImportCxxTests tests
  DISABLE_FLOATING_POINT_EXCEPTIONS
  RENDERING_FACTORY)

=== Rendering/CellGrid/Testing/Python/CMakeLists.txt ===
vtk_add_test_python(
  TestCellGridHardwarePicker.py,NO_RT,NO_VALID
  TestCellGridRenderedAreaPicker.py,NO_RT,NO_VALID
  TestCellGridRenderedAreaPickerWithPolyData.py,NO_RT,NO_VALID
  TestCellGridRendering.py,NO_RT
)

=== ThirdParty/kissfft/vtkkissfft/tools/Makefile ===
WARNINGS=-W -Wall -Wstrict-prototypes -Wmissing-prototypes -Waggregate-return \
    -Wcast-align -Wcast-qual -Wnested-externs -Wshadow -Wbad-function-cast \
    -Wwrite-strings

ifeq "$(DATATYPE)" ""
 DATATYPE=float
endif

ifeq  "$(DATATYPE)" "int32_t"
 TYPEFLAGS=-DFIXED_POINT=32
endif

ifeq  "$(DATATYPE)" "int16_t"
 TYPEFLAGS=-DFIXED_POINT=16
endif

ifeq  "$(DATATYPE)" "simd"
 TYPEFLAGS=-DUSE_SIMD=1 -msse
endif

ifeq "$(TYPEFLAGS)"  ""
 TYPEFLAGS=-Dkiss_fft_scalar=$(DATATYPE)
endif

ifneq ("$(KISS_FFT_USE_ALLOCA)","")
	CFLAGS+= -DKISS_FFT_USE_ALLOCA=1
endif 
CFLAGS+= $(CFLAGADD)


FFTUTIL=fft_$(DATATYPE)
FASTFILT=fastconv_$(DATATYPE)
FASTFILTREAL=fastconvr_$(DATATYPE)
PSDPNG=psdpng_$(DATATYPE)
DUMPHDR=dumphdr_$(DATATYPE)

all: $(FFTUTIL) $(FASTFILT) $(FASTFILTREAL) 
# 	$(PSDPNG) 
#	$(DUMPHDR)

#CFLAGS=-Wall -O3 -pedantic -march=pentiumpro -ffast-math -fomit-frame-pointer $(WARNINGS)
# If the above flags do not work, try the following
CFLAGS=-Wall -O3 $(WARNINGS) 
# tip: try -openmp or -fopenmp to use multiple cores

$(FASTFILTREAL): ../kiss_fft.c kiss_fastfir.c kiss_fftr.c
	$(CC) -o $@ $(CFLAGS) -I.. $(TYPEFLAGS) -DREAL_FASTFIR  $+ -DFAST_FILT_UTIL -lm 

$(FASTFILT): ../kiss_fft.c kiss_fastfir.c
	$(CC) -o $@ $(CFLAGS) -I.. $(TYPEFLAGS) $+  -DFAST_FILT_UTIL -lm

$(FFTUTIL): ../kiss_fft.c fftutil.c kiss_fftnd.c kiss_fftr.c kiss_fftndr.c
	$(CC) -o $@ $(CFLAGS) -I.. $(TYPEFLAGS) $+ -lm

$(PSDPNG): ../kiss_fft.c psdpng.c kiss_fftr.c
	$(CC) -o $@ $(CFLAGS) -I.. $(TYPEFLAGS) $+ -lpng -lm

$(DUMPHDR): ../kiss_fft.c dumphdr.c
	$(CC) -o $@ $(CFLAGS) -I.. $(TYPEFLAGS) $+ -lm

clean:
	rm -f *~ fft fft_* fastconv fastconv_* fastconvr fastconvr_* psdpng psdpng_*

=== PKGBUILD ===
# Maintainer: Sergey Popov <popov.sa@gmail.com>
# Contributor: Mario Emmenlauer <memmenlauer@biodataanalysis.de>

_realname=vtk
pkgbase="mingw-w64-${_realname}"
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=9.4.2
pkgrel=2
pkgdesc="A software system for 3D computer graphics, image processing and visualization (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.vtk.org/"
msys2_repository_url="https://gitlab.kitware.com/vtk/vtk"
msys2_references=(
  'archlinux: vtk'
  "cpe: cpe:/a:vtk:vtk"
)
license=("spdx:BSD-3-Clause")
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-double-conversion"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-fmt"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-glew"
         "${MINGW_PACKAGE_PREFIX}-tbb"
         "${MINGW_PACKAGE_PREFIX}-jsoncpp"
         "${MINGW_PACKAGE_PREFIX}-libharu"
         "${MINGW_PACKAGE_PREFIX}-libjpeg"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread-git"
         "${MINGW_PACKAGE_PREFIX}-lz4"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openxr-sdk"
         "${MINGW_PACKAGE_PREFIX}-pugixml"
         $([[ ${MSYSTEM} == MINGW64 ]] || echo "${MINGW_PACKAGE_PREFIX}-verdict")
         "${MINGW_PACKAGE_PREFIX}-xz"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-adios2"
             "${MINGW_PACKAGE_PREFIX}-alembic"
             $([[ ${MSYSTEM} == MINGW64 ]] || echo "${MINGW_PACKAGE_PREFIX}-anari-sdk")
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-cgns"
             "${MINGW_PACKAGE_PREFIX}-cli11"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-fast_float"
             "${MINGW_PACKAGE_PREFIX}-ffmpeg"
             "${MINGW_PACKAGE_PREFIX}-fontconfig"
             "${MINGW_PACKAGE_PREFIX}-gdal"
             "${MINGW_PACKAGE_PREFIX}-gl2ps"
             "${MINGW_PACKAGE_PREFIX}-hdf5"
             "${MINGW_PACKAGE_PREFIX}-liblas"
             "${MINGW_PACKAGE_PREFIX}-libmariadbclient"
             "${MINGW_PACKAGE_PREFIX}-libpng"
             "${MINGW_PACKAGE_PREFIX}-libogg"
             "${MINGW_PACKAGE_PREFIX}-libtheora"
             "${MINGW_PACKAGE_PREFIX}-libxml2"
             "${MINGW_PACKAGE_PREFIX}-netcdf"
             "${MINGW_PACKAGE_PREFIX}-openslide"
             "${MINGW_PACKAGE_PREFIX}-opencascade"
             "${MINGW_PACKAGE_PREFIX}-openturns"
             "${MINGW_PACKAGE_PREFIX}-openvdb"
             "${MINGW_PACKAGE_PREFIX}-openvr"
             "${MINGW_PACKAGE_PREFIX}-pdal"
             # "${MINGW_PACKAGE_PREFIX}-pegtl" https://gitlab.kitware.com/vtk/vtk/-/issues/18151
             "${MINGW_PACKAGE_PREFIX}-postgresql"
             "${MINGW_PACKAGE_PREFIX}-proj"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-sqlite3"
             # "${MINGW_PACKAGE_PREFIX}-tk"
             "${MINGW_PACKAGE_PREFIX}-unixodbc"
             "${MINGW_PACKAGE_PREFIX}-utf8cpp"
             )
optdepends=("${MINGW_PACKAGE_PREFIX}-adios2: I/O ADIOS2"
            "${MINGW_PACKAGE_PREFIX}-alembic: I/O Alembic"
            "${MINGW_PACKAGE_PREFIX}-boost-libs: InfovisBoost and InfovisBoostGraphAlgorithms modules"
            "${MINGW_PACKAGE_PREFIX}-cgns: CGNS Reader"
            "${MINGW_PACKAGE_PREFIX}-ffmpeg: I/O FFMPEG"
            "${MINGW_PACKAGE_PREFIX}-fontconfig: Fontconfig Rendering"
            "${MINGW_PACKAGE_PREFIX}-gdal: I/O GDAL"
            "${MINGW_PACKAGE_PREFIX}-gl2ps: PS Rendering"
            "${MINGW_PACKAGE_PREFIX}-hdf5: I/O HDF5"
            "${MINGW_PACKAGE_PREFIX}-liblas: I/O LAS"
            "${MINGW_PACKAGE_PREFIX}-libmariadbclient: I/O MySQL/MariaDB"
            "${MINGW_PACKAGE_PREFIX}-libpng: I/O PNG Images"
            "${MINGW_PACKAGE_PREFIX}-libogg: I/O OGG and Theora"
            "${MINGW_PACKAGE_PREFIX}-libtheora: I/O OGG and Theora"
            "${MINGW_PACKAGE_PREFIX}-libxml2: I/O Infovis"
            "${MINGW_PACKAGE_PREFIX}-netcdf: I/O netCDF"
            "${MINGW_PACKAGE_PREFIX}-opencascade: I/O OCCT"
            "${MINGW_PACKAGE_PREFIX}-openslide: DomainsMicroscopy"
            "${MINGW_PACKAGE_PREFIX}-openturns: OpenTURNS Filter"
            "${MINGW_PACKAGE_PREFIX}-openvdb: I/O OpenVDB"
            "${MINGW_PACKAGE_PREFIX}-openvr: OpenVR Rendering"
            "${MINGW_PACKAGE_PREFIX}-pdal: I/O PDAL"
            "${MINGW_PACKAGE_PREFIX}-postgresql: I/O PostgreSQL"
            "${MINGW_PACKAGE_PREFIX}-proj: GEOVis"
            "${MINGW_PACKAGE_PREFIX}-python: Python bindings"
            "${MINGW_PACKAGE_PREFIX}-python-matplotlib: Matplotlib renderer"
            "${MINGW_PACKAGE_PREFIX}-qt6-base: Qt Rendering"
            "${MINGW_PACKAGE_PREFIX}-qt6-declarative: Qt Qml plugin"
            "${MINGW_PACKAGE_PREFIX}-sqlite3: I/O SQL"
            # "${MINGW_PACKAGE_PREFIX}-tk: TCL bindings, Python Tk widgets"
            "${MINGW_PACKAGE_PREFIX}-unixodbc")
if [[ ${MSYSTEM} != MINGW64 ]]; then
  optdepends+=("${MINGW_PACKAGE_PREFIX}-anari-sdk: ANARI Rendering")
fi
source=(https://www.vtk.org/files/release/${pkgver%.*}/VTK-${pkgver}.tar.gz
        "001-no-exact-version-for-fast_float.patch"
        "002-llvm-19-compatibility.patch"
        "003-fix-build-with-fmt-11.patch"
        "004-accept-future-versions-of-boost-and-occ.patch"
        "005-remove-unused-method-from-mir-tables.patch"
        "006-fix-compile-error-for-contour-tree-print.patch"
        "007-dll-export-some-functions.patch"
        "008-update-to-diy-3.6.0.patch"
        "009-diy-3-compatibility.patch"
        "011-anari-integer-types.patch"
        "012-fix-build-with-netcdf-4.9.3.patch")
sha256sums=('36c98e0da96bb12a30fe53708097aa9492e7b66d5c3b366e1c8dc251e2856a02'
            '411b0521fcd2864acae0af20ba6334f69f7c605c9e31996529f64aa749d61065'
            '410ddfbb2acb66746771a0e1f3ad81230904f712729af29cd26e8aaaa19dc48e'
            '2d1795111b410e0fbb8e7b08fab2e83e37e74ca0d7fd6685d435d4b27f355b87'
            'a44b3ba4bdc02be4767ff48b8a7fd4206a53756a881421fca99f538b08a7b48c'
            '66e3ac19197fb9f6f49dc98a746919ed025619ab8dae433d153c22ca595d92bc'
            'ace675cf8a9081532756b66d4f1ca1b03b12dad719b79e8cfa60ee6d60e2eeaf'
            '6cc0c44b2cb9693b8ae101fdde186561633fc6e6629c6e797231331895baa5df'
            '7602c7b4afa61f57f27022d4ea015c6e3c1d4ab8df5907ca828e08bb48c26b20'
            '19ffd04b06b4c3c0c3f0b1b375cbac956191d4b7d3fa1066dc62bbfe78d69908'
            'd76aa1788bbe2dd14390d4c7a4e65bcd652e4521324a7982ef7ead2306c82436'
            'eabe075c71ea6bbabfe3d0f1bf10f01ec299c88a8a825866f944eeb0b067aa2e')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  apply_patch_with_msg \
    001-no-exact-version-for-fast_float.patch \
    002-llvm-19-compatibility.patch \
    003-fix-build-with-fmt-11.patch \
    004-accept-future-versions-of-boost-and-occ.patch \
    005-remove-unused-method-from-mir-tables.patch \
    006-fix-compile-error-for-contour-tree-print.patch \
    008-update-to-diy-3.6.0.patch \
    009-diy-3-compatibility.patch \
    011-anari-integer-types.patch \
    012-fix-build-with-netcdf-4.9.3.patch

  # Succeeds with Clang but fails with GCC!
  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    apply_patch_with_msg \
      007-dll-export-some-functions.patch
  fi
}

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MSYSTEM} == MINGW64 ]]; then
    _extra_config+=("-DVTK_MODULE_ENABLE_VTK_RenderingAnari=NO"
                    "-DVTK_MODULE_USE_EXTERNAL_VTK_verdict=OFF")
  fi

  CFLAGS+=" ${CPPFLAGS}"
  CXXFLAGS+=" ${CPPFLAGS} -D_USE_MATH_DEFINES -w"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -Wno-dev \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    -DCMAKE_INSTALL_LICENSEDIR=share/licenses/vtk \
    -DBUILD_SHARED_LIBS=ON \
    -DPython3_EXECUTABLE="${MINGW_PREFIX}/bin/python.exe" \
    -DVTK_BUILD_TESTING=OFF \
    -DVTK_VERSIONED_INSTALL=OFF \
    -DVTK_BUILD_ALL_MODULES=ON \
    -DVTK_GROUP_ENABLE_MPI=NO \
    -DVTK_GROUP_ENABLE_Web=NO \
    -DVTK_MODULE_ENABLE_VTK_FiltersParallelVerdict=WANT \
    -DVTK_MODULE_ENABLE_VTK_FiltersTemporal=WANT \
    -DVTK_MODULE_ENABLE_VTK_IOERF=WANT \
    -DVTK_MODULE_ENABLE_VTK_IOFDS=WANT \
    -DVTK_MODULE_ENABLE_VTK_RenderingOpenXRRemoting=NO \
    -DVTK_MODULE_ENABLE_VTK_RenderingZSpace=NO \
    -DVTK_USE_EXTERNAL=ON \
    -DVTK_MODULE_USE_EXTERNAL_VTK_exprtk=OFF \
    -DVTK_MODULE_USE_EXTERNAL_VTK_ioss=OFF \
    -DVTK_MODULE_USE_EXTERNAL_VTK_pegtl=OFF \
    -DVTK_MODULE_USE_EXTERNAL_VTK_token=OFF \
    -DVTK_WRAP_JAVA=OFF \
    -DVTK_WRAP_PYTHON=ON \
    -DVTK_SMP_IMPLEMENTATION_TYPE=TBB \
    -DVTK_SMP_ENABLE_SEQUENTIAL=ON \
    -DVTK_SMP_ENABLE_STDTHREAD=ON \
    -DVTK_SMP_ENABLE_OPENMP=ON \
    -DVTK_USE_VIDEO_FOR_WINDOWS=ON \
    -DVTK_ENABLE_OSPRAY=OFF \
    -DVTK_ENABLE_REMOTE_MODULES=OFF \
    -DVTK_IGNORE_CMAKE_CXX11_CHECKS=ON \
    "${_extra_config[@]}" \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/Copyright.txt \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE

  # Remove third party CMake patching for older versions than ours
  rm -rv "${pkgdir}"${MINGW_PREFIX}/lib/cmake/vtk/patches/3.{1{3,6,9},2{0,2,3}}
  # … as well as duplicate copies
  rm -rv "${pkgdir}"${MINGW_PREFIX}/lib/cmake/vtk/vtkm/{Find*.cmake,cmake/{Find*.cmake,3.15}}

}
